//--------------------------------------------------------------------------
//       SOFT
//  DMAALL
//    BC4.5    OWL2.0
//--------------------------------------------------------------------------

#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dialog.h>
#include <owl\edit.h>
#include <owl\checkbox.h>
#include <stdio.h>
#pragma hdrstop
#include "multi_i.rh"
#include "lcard_ad.h"



TEdit* RateEd;       //    
TEdit* ChanEd;       //    
TStatic* GraphStatic;
TCheckBox* ModeCB;   //   - DMA  

//--------------------------------------------------------------------------
//  TGraphStatic,    
//--------------------------------------------------------------------------
class TGraphStatic:public TStatic {
public:
   void EvPaint();
   TGraphStatic(TWindow* parent, int resourceId, uint textLen = 0, TModule*
module = 0): TStatic(parent, resourceId, textLen, module) {};
DECLARE_RESPONSE_TABLE(TGraphStatic);
};

DEFINE_RESPONSE_TABLE1(TGraphStatic, TStatic)
   EV_WM_PAINT,
END_RESPONSE_TABLE;

//-----------------------------------------------------------------
//    ' TStatic    wmPaint
//-----------------------------------------------------------------

COLORREF Get16Color(int i)
{
   i+=10;
   return RGB((i&4) ? 255:0,(i&2) ? 255:0,(i&1) ? 255:0);
};


#define NKadr        200  //    
void TGraphStatic::EvPaint()
{
int    i,j;
float  Max;
char   sChan[80], sRate[80];
int    iChan=0, iRate=0;
   TPaintDC DC(HWindow);

   TPen pen(RGB(255,255,0));
   TBrush brush(RGB(0,0,127));
   DC.SelectObject(pen);
   DC.SelectObject(brush);

   ChanEd->GetText(sChan, sizeof(sChan));
   RateEd->GetText(sRate, sizeof(sRate));
   sscanf(sChan, "%d", &iChan);
   sscanf(sRate, "%d", &iRate);
   if (iRate<5) iRate=5;
   if (iChan<1) iChan=1;
   if (iChan>32) iChan=32;

   int* Data = new int[iChan*NKadr];
   //     
   int* Channels = new int[iChan];
   for (j=0; j<iChan; j++)
      Channels[j]=CREATE_CHANNEL(j,0,0);

   //     
   if (ModeCB->GetCheck()==BF_CHECKED)
      {
      //    DMA
      DMAALL(Data, NKadr, Channels,iChan,iRate,0);
      while (!DMA_TEST()) ;
      DMA_OFF();
      }
   else
      //    
      SOFT(Data, NKadr, Channels, iChan, iRate);



   Max=1.;
   for (j=0; j<NKadr; j++)
      for (i=0; i<iChan; i++)
         if (abs(Data[j*iChan+i])>Max) Max=abs(Data[j*iChan+i]);
   Max=Max*1.2;

   DC.Rectangle(0,0, Attr.W-1, Attr.H-1);
   DC.MoveTo(0, Attr.H/2);
   DC.LineTo(Attr.W-1, Attr.H/2);

   for (i=0; i<iChan; i++)
      {
      DC.MoveTo(0, -1.*Data[i]/Max*Attr.H/2 + Attr.H/2);

      TPen* GraphPen=new TPen(Get16Color(i));
      DC.SelectObject(*GraphPen);
      for (j=1; j<NKadr; j++)
         {
         DC.LineTo(1.*j/NKadr*Attr.W,
            -1.*Data[j*iChan+i]/Max*Attr.H/2 + Attr.H/2);
         };
      delete GraphPen;
      };

   delete[] Channels;
   delete[] Data;

   DC.RestorePen();
   DC.RestoreBrush();
};


//--------------------------------------------------------------------------
//     TMainDialog
//--------------------------------------------------------------------------
class TMainDialog:public TDialog {
public:
   TMainDialog(TWindow* parent, TResId resId);
protected:
   void wmTimer();
   void SetupWindow();
   ~TMainDialog();
   void EvTimer(uint timerId);
DECLARE_RESPONSE_TABLE(TMainDialog);
};

DEFINE_RESPONSE_TABLE1(TMainDialog, TDialog)
  EV_WM_TIMER,
END_RESPONSE_TABLE;

TMainDialog::TMainDialog(TWindow* parent, TResId resId)
   : TWindow((TWindow*)0), TDialog(Parent, resId)
{
   RateEd=new TEdit(this, ID_RateEd);
   ChanEd=new TEdit(this, ID_ChanEd);
   GraphStatic=new TGraphStatic(this, ID_GraphStatic);
   ModeCB = new TCheckBox(this, ID_ModeCB);
};

void TMainDialog::SetupWindow(void)
{
TDialog::SetupWindow();
SetTimer(ID_Timer, 500);
LOW_POWER(0);
};


TMainDialog::~TMainDialog(void)
{
KillTimer(ID_Timer);
};

void TMainDialog::EvTimer(uint timerId)
{
TRect R;
R.left=GraphStatic->Attr.X;
R.top=GraphStatic->Attr.Y;
R.right=GraphStatic->Attr.X + GraphStatic->Attr.W;
R.bottom=GraphStatic->Attr.Y + GraphStatic->Attr.H;
InvalidateRect(R, FALSE);
};


//--------------------------------------------------------------------------
//   TMainApp
//--------------------------------------------------------------------------
class TMainApp: public TApplication {
public:
   TMainApp(const char far* name) :TApplication(name) {};
   void InitMainWindow();
};

void TMainApp::InitMainWindow()
{
   EnableBWCC();

   TMainDialog *cp;
   cp = new TMainDialog(0, ID_MAINDIALOG);

   MainWindow =
      new TFrameWindow(
         0,
         "  ",
         cp,
         TRUE);
   MainWindow->Attr.Style &= ~(WS_MAXIMIZEBOX | WS_THICKFRAME);
};

#pragma argsused
int OwlMain( int argc, char* argv[])
{
   TMainApp app("");
   return app.Run();
};

